====== inet-3.x ======

2017-10-02  ------ inet-3.6.2 released ------

2017-07-06  ------ inet-3.6.1 released ------

2017-06-09  ------ inet-3.6.0 released ------

2017-05-31  Zoltan Bojthe

	CID 179330 Dereference before null check

2017-02-20  ------ inet-3.5.0 released ------

2016-06-15  ------ inet-3.4.0 released ------

2016-01-04  Levente Meszaros

	Added VehicleMobility that simulates turning at waypoints.

2016-06-01  ------ inet-3.3.0 released ------

2016-04-06  ------ inet-3.2.4 released ------

2016-03-16  ------ inet-3.2.3 released ------

2016-03-11  ------ inet-3.2.2 released ------

2016-01-21  ------ inet-3.2.1 released ------

2015-12-16  ------ inet-3.2.0 released ------

2015-10-14  Levente Meszaros

	Mobility: Fixed sign of lastSpeed.

2015-09-29  Levente Meszaros

	Mobility: Replace PI with M_PI to avoid conflicts with OSG.

2015-10-26  ------ inet-3.1.1 released ------

2015-10-15  ------ inet-3.1.0 released ------

2015-06-22  ------ inet-3.0.0 released ------

2015-05-13  ------ inet-2.99.1 released ------

2015-03-26  Levente Meszaros

	Added lastSpeed calculation to RectangleMobility.

2015-01-21  Zoltan Bojthe

	Applied C++ source code modernizer.

2014-12-17  Zoltan Bojthe

	Fixed defects found by static code analyzer (Coverity).

2014-11-26  Levente Meszaros

	Fixed memory management problems found by valgrind memcheck.

2014-11-07  ------ inet-2.99.0 released ------

2014-09-18  Andras Varga

	Moved all sources under the src/inet directory, so that all #include
	statements begin with "inet/". The motivation is to rule out potential
	filename clashes when multiple model frameworks are used together.

	HINT: You can use the "opp_githist" command in inet/_scripts to find
	all previous locations of the sources in this directory, and to view
	the full history in gitk. Normal invocations of gitk can only show
	file history back to the most recent move operation.

2014-07-30  Andras Varga

	Changes on the inet-3.x branch so far:

	Code formatting (Zoltan Bojthe)
	- using uncrustify, see _scripts/reformat/*
	- common style for header guards

	Namespace (Zoltan Bojthe, Zsolt Prontvai)
	- code has been moved into the inet namespace

	Init stages (Zoltan Bojthe, Andras Varga)
	- init stages: reorganized by layers

	Signals (Zoltan Bojthe)
	- replace INotifiable and NotificationBoard by signals for
	  publish/subscribe communication

	Logging (Zoltan Bojthe, Benjamin Seregi)
	- EV log statements revised and categorized: EV_ERROR, EV_WARN,
	  EV_INFO, EV_DETAIL, EV_DEBUG, EV_TRACE

====== inet-2.x ======

2015-03-04  ------ inet-2.6 released ------

2014-11-07  ------ inet-2.5.1 released ------

2014-10-29  ------ inet-2.5.0 released ------

2014-06-12  ------ inet-2.4.0 released ------

2014-03-19  ------ inet-2.3.0 released ------

2014-02-06  Zoltan Bojthe

	Backport: mobility

	fingerprints of MoBAN mobility are changed

2013-10-24  Rudolf Hornig

	Added missing INET_API macros to propely support DLL exporting with Visual C++

2013-08-22  ------ inet-2.2.0 released ------

2013-06-11  Zoltan Bojthe

	StaticGridMobility: Added new parameters to specify the number of rows/columns and
	the horizontal/verical separation between the nodes. Note that the way the node
	positions are calculated has changed. You may need to update your INI files (see
	the NED file for more info.)

2013-05-29  Levente Meszaros

	TurtleMobility: Fixed getting the position from a mobility signal
	listener during initialize. The script was resumed before initialize
	finished, resulting in incorrect positioning.

2012-12-27  Andras Varga

	FWMath.h: TraCIMobility didn't compile with MSVC

2013-01-30  ------ inet-2.1.0 released ------

2012-08-07  ------ inet-2.0.0 released ------

2012-07-18  Alfonso Ariza Quintana

	Bugfix in Ns2MotionMobility when the node is stopped.

2012-06-25  ------ inet-1.99.5 released ------

2012-05-18  Rudolf Hornig

	Mobility models now correctly refer to the constraint area.

2012-04-27  Levente Meszaros

	Mobility: added default icon

2012-03-20  ------ inet-1.99.4 released ------

2012-03-19 Levente Meszaros

	fixed infinite loop when nextChange is set to current simulation time

2012-02-24  ------ inet-1.99.3 released ------

2012-01-05  Zoltan Bojthe

	Coord: removed "copy from a pointer" constructor and its usages

2011-12-19  Zoltan Bojthe

	Mobility: minor fix for MobilityBase: use logical OR instead bitwise OR

2011-12-19  Andras Varga

	MassMobility: bugfix: "angle" parameter (now renamed to "startAngle")
	was not read

2011-11-22  Zoltan Bojthe

	mobility: fix for LinearMobility acceleration

	fixed bug: movement not started when speed is 0 and acceleration > 0
	also add examples with acceleration

2011-11-22  Zoltan Bojthe

	mobility: fix ANSimMobility and BonnMotionMobility: generates next event
	to same time when movement finished

	see also bug #451 in TurtleMobility

2011-11-22  Zoltan Bojthe

	mobility: fix for #451: TurtleMobility generates next event to same time
	when xml finished (with Levente Meszaros)

2011-11-21  Levente Meszaros

	Mobility: fixed Ns2MotionMobility

	Removed documentation that was referring to BonnMotion due to
	copy-paste. Fixed setTargetPosition to avoid problems when nextChange
	was -1.

2011-11-21  Levente Meszaros

	Mobility: fixed bug 414 found at
	http://dev.omnetpp.org/bugs/view.php?id=414

	Replaced or guarded nextChange += statements to avoid problems when
	nextChange is -1.

2011-11-18  ------ INET-1.99.2 released ------

2011-10-27  Levente Meszaros

	Mobility: fixed previous commit wrt. scheduling the self message

	MovingMobilityBase should schedule the self message after
	setTargetPosition is called in subclasses in initialize stage 1.

2011-10-25  Levente Meszaros

	Mobility: moved initialization into earlier stages

	The position signal must be emitted early enough so that protocols can
	properly initialize. Updated MoBAN models to correctly set initial
	position in the display strings.

2011-10-25  Levente Meszaros

	Mobility: refactored mobility module constraint area parameters

	Replaced constraintArea[XYZ] and constraintAreaSize[XYZ] with
	constraintAreaMin[XYZ] and constraintAreaMax[XYZ]. Added checks for non
	finite coordinates after initialize.

2011-09-16  Levente Meszaros

	Mobility: changed default value for constraintAreaSize* to -1 that is
	unbounded

2011-09-16  Levente Meszaros

	Mobility: renamed constraintAreaWidth to constraintAreaSizeX (and
	friends)

2011-09-15  Levente Meszaros

	Mobility: added 3d support to BonnMotionMobility and CircleMobility

2011-09-15  Levente Meszaros

	Mobility: removed meaningless default parameter values

	Also removed superfluous quotes around units. Follow changes with
	examples.

2011-09-15  Levente Meszaros

	Mobility: copied over MoBAN mobility modules from MiXiM

	The MoBAN configuration files and syntax did not change. The mobility
	models should behave exactly the same way as they did in MiXiM except
	they are able to provide the exact position at any simulation time.

	The Posture and PostureTransition classes were copied without
	significant changes. The MoBANCoordinator and MoBANLocal classes had to
	be refactored due to the new mobility API that requires the mobility
	modules to provide their position and speed at any simulation time. Some
	NED parameters were removed, because they are already present in
	supermodules. Some C++ class members were also removed, because they are
	not used any more. The C++ superclasses provide the required
	functionality they were used for.

2011-09-15  Levente Meszaros

	Mobility: eliminated duplicated conditionals

	Checking the stationary flag and updateInterval was done in multiple
	places. Now subclasses can better reuse scheduleUpdate. Also a mobility
	that becomes stationary at some point may become moving again later if
	nextChange is not -1.

2011-09-15  Levente Meszaros

	Mobility: comments and cosmetics

2011-09-15  Levente Meszaros

	Mobility: reflect mobility state changes in the visual representation
	module

	Renamed hostModule to visualRepresentation. Splitted positionUpdated
	into two functions to ease overriding. BasicModule subclasses (such as
	mobility modules) should be useable without a full blown host. Changed
	findHost to be able to return NULL if requested to do so. The default
	findHost behavior did not change.

2011-09-13  Levente Meszaros

	Mobility: lastSpeed is automatically calculated by
	LineSegmentsMobilityBase

2011-07-19  Levente Meszaros

	Refactored mobility modules.

	See ChangeLog in the mobility directory for details.

2011-06-10  Zoltan Bojthe

	cosmetics: code style, remove some codes in comments

2011-06-03  Andras Varga

	cosmetics: space usage made somewhat more consistent throughout the code

	Notes:
	- if you have an INET fork and want to compare the code, use the
	 "Ignore spaces" option of your visual diff tool. Most tools have
	 this option; Meld and Araxis Merge certainly do.

	- I used omnetpp/_scripts/tidymodel/spaces.pl, plus some manual tweaks

2011-05-30  ------ INET-1.99.1 released ------

2011-05-28  Andras Varga

	cosmetics: end-line spaces removed, using spaces.pl in OMNeT++.

2011-05-19  Rudolf Hornig

	Original channel controller modified to work with radios instead of
	hosts. Channel controller extended is removed.

2011-05-11  Andras Varga

	Compile fixes for MSVC

	- disambiguate arg types for pow(), sqrt(), etc. (ambiguity caused
	  compile errors)
	- added implementations for missing C99 functions
	- MSVC does not have <stdint.h>, but most of its declarations are
	  already provided by <omnetpp.h>

2011-05-10  Andras Varga

	Packages moved: battery, mobility, scenario

	mobility models: src/mobility -> src/mobility/models;
	IMobility: base/mobility -> src/mobility

	battery models: src/battery -> src/battery/models;
	IBattery (new): -> src/battery

	ScenarioManager: src/world -> src/world/scenario

	IManetRouting: src/base/manetrouting -> src/networklayer

2011-05-06  Zoltan Bojthe

	Mobility made independent of ChannelControl

	- moved ChannelControl* to world/radio

	- merged ChannelAccessExtended to ChannelAccess

	- host registration was moved from Mobility to the radio modules.
	 (There can be multiple radios per host, so ChannelControlExtended
	 now maintains a registration count for each host.)
	 Mobility now doesn't refer to ChannelControl at all, so one can
	 create mobile networks that don't contain ChannelControl at all;
	 ChannelControl is only needed for radio communication.

	- global playgroundSizeX/Y parameters have been replaced with
	 per-mobility constraintAreaX/Y, constraintAreaWidth/Height
	 parameters for most mobility modules
	 NOTE: Playground is now conceptionally unlimited, only the
	 movement of individual nodes are (can be) constrained to
	 rectangular areas. (This change was needed because mobility
	 modules now don't access ChannelControl that used to contain
	 the playgroundSizeX/Y parameters.)

	- x,y parameters have been renamed to initialX/Y; a new
	 initFromDisplayString parameter controls whether the initial
	 coordinates come from the display string or from the parameters
	 (for most modules; some mobility modules don't have these parameters)

	Example simulations are updated in a separate commit.

2011-04-21  Rudolf Hornig

	Added new mobility models.

2011-03-03  ------ INET-1.99.0 released ------

2011-03-02  Zoltan Bojthe

	change opp_error to throw cRuntimeError

2011-03-01  Rudolf Hornig

	Module interface renaming.

2011-02-28  Rudolf Hornig

	StandardHost fixes

2010-11-22  Rudolf Hornig

	Added plugin interfaces to the network layer to be able to add
	drop/duplicate modules, througput meters etc.

2011-02-22  Andras Varga

	Swiched NED documentation comments to explicit hyperlinking of NED
	type names, using tilde. Example: "TCP" was changed to "~TCP"
	wherever the module and not the protocol was meant.

	The reason for the switch was that autolinking produced too many
	false hits (e.g. "TCP connection" and "IP address" would link
	to the TCP and IP modules.)

2010-08-08  Andras Varga

	move all dtd and xsd files under etc/; fix xsd ref in example
	sniffer.xml files

2009-07-19  Andras Varga

	added further module @labels (ethernet-node, wireless-node, mpls-node);
	added default icons to several module types

2009-03-25  ------ INET-20090325 released ------

2008-07-07  Levente Meszaros

	* Added IMobility that defines the public C++ interface (and only that) for
	  mobility modules.

	* Renamed BasicMobility (because it is not a mobility by itself) to
	  MobilityBase.

	* Changed notification mechanism from the NotificationBoard to the OMNeT++
	  signalling mechanism. The signal name is 'mobilityStateChanged' and its
	  argument is the mobility module itself.

	* Removed the now obsolete NF_HOSTPOSITION_UPDATED notification from the
	  NotificationBoard.

	* Updated ManetRoutingBase and ChannelAccess to subscribe to the new signal.

	* Added new base class called MovingMobilityBase that handles updateInterval
	  in a general way. Updated subclasses to avoid repeating this code.

	* Properly implement reflectIfOutside and wrapIfOutside when the position
	  is further from the constraint area than the area's size. (without loops)

	* Properly implement linear interpolation in LineSegmentsMobilityBase so
	  that the current position can be provided at any simulation time.

	* Refactored all mobility models for the new super classes and to support
	  providing the current position and speed at the current simulation time.

	* Deleted NoMobility and changed mobility modules to be optional in the hosts.

	* Renamed NullMobility to StationaryMobility to better express its intended
	  usage.

	* Copied over and updated TractorMobility from MiXiM.

	* Updated all modules that use mobility and all examples including NED files
	  and ini files to work with the new model.

	* Added a couple of new examples to the mobility examples package to be able
	  to test all existing models.

	* Added a MobilityAccess class to get a mobility module pointer easily.

	* Fixed relative path in the run scripts for mobility examples.

2008-01-01..2009-03-25  Andras Varga, Rudolf Hornig

	Porting of INET to OMNeT++ 4.0, and some general face lift:
	* better directory structure (names changed to lowercase; moved sources
	  under src/; better names, e.g. networkinterfaces -> linklayer)
	* build system to use a deep makefile
	* updated the C++ code for the 4.0 API (follow name changes; use
	  int64-based simtime_t; use cPacket; etc.)
	* NED files converted to 4.0 syntax
	* make use of new features in NED files (module interfaces, inout
	  gates, @unit, etc.)

2005-08-04  Andras Varga

	Initial checkin of the mobility models. Most models are taken from MF-1.0a5
	(Mobility Framework, developed at TKN, TU Berlin by Daniel Willkomm and
	others), and underwent some refactoring for the INET Framework.

	New models written by Andras include: TurtleMobility, RectangleMobility,
	CircleMobility, BonnMotionMobility, ANSimMobility.

	If you are interested in the early history of the code, change
	to the project root and type

	$ gitk -- Mobility INET/src/mobility src/mobility
